org.apache.tomcat.dbcp.pool

## Class BaseKeyedObjectPool<K,V>

- java.lang.Object
- - org.apache.tomcat.dbcp.pool.BaseKeyedObjectPool<K,V>

- Type Parameters:
    `K` - the type of keys in this pool
    `V` - the type of objects held in this pool
  All Implemented Interfaces:
    KeyedObjectPool<K,V>
  Direct Known Subclasses:
    GenericKeyedObjectPool, StackKeyedObjectPool

      public abstract class BaseKeyedObjectPool<K,V>
      extends java.lang.Object
      implements KeyedObjectPool<K,V>

  A simple base implementation of `KeyedObjectPool`. Optional operations are implemented to either do nothing, return a value indicating it is unsupported or throw `UnsupportedOperationException`.
  Since:
    Pool 1.0
  Author:
    Rodney Waldhoff, Sandy McArthur

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `BaseKeyedObjectPool()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addObject(K key)` Not supported in this base implementation.
    `protected void` | `assertOpen()` Throws an `IllegalStateException` when this pool has been closed.
    `abstract V` | `borrowObject(K key)` Obtains an instance from this pool for the specified `key`.
    `void` | `clear()` Not supported in this base implementation.
    `void` | `clear(K key)` Not supported in this base implementation.
    `void` | `close()` Close this pool.
    `int` | `getNumActive()` Not supported in this base implementation.
    `int` | `getNumActive(K key)` Not supported in this base implementation.
    `int` | `getNumIdle()` Not supported in this base implementation.
    `int` | `getNumIdle(K key)` Not supported in this base implementation.
    `abstract void` | `invalidateObject(K key, V obj)` Invalidates an object from the pool.
    `protected boolean` | `isClosed()` Has this pool instance been closed.
    `abstract void` | `returnObject(K key, V obj)` Return an instance to the pool.
    `void` | `setFactory(KeyedPoolableObjectFactory<K,V> factory)` Deprecated. to be removed in pool 2.0

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### BaseKeyedObjectPool

          public BaseKeyedObjectPool()

  - ### Method Detail

    - #### borrowObject

          public abstract V borrowObject(K key)
                                  throws java.lang.Exception

      Obtains an instance from this pool for the specified `key`.

      Instances returned from this method will have been either newly created with `makeObject` or will be a previously idle object and have been activated with `activateObject` and then validated with `validateObject`.

      By contract, clients must return the borrowed object using `returnObject`, `invalidateObject`, or a related method as defined in an implementation or sub-interface, using a `key` that is `equivalent` to the one used to borrow the instance in the first place.

      The behaviour of this method when the pool has been exhausted is not strictly specified (although it may be specified by implementations). Older versions of this method would return `null` to indicate exhaustion, newer versions are encouraged to throw a `NoSuchElementException`.

      Specified by:
        `borrowObject` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key used to obtain the object
      Returns:
        an instance from this pool.
      Throws:
        `java.lang.IllegalStateException` - after `close` has been called on this pool
        `java.lang.Exception` - when `makeObject` throws an exception
        `java.util.NoSuchElementException` - when the pool is exhausted and cannot or will not return another instance

    - #### returnObject

          public abstract void returnObject(K key,
                          V obj)
                                     throws java.lang.Exception

      Return an instance to the pool. By contract, `obj` must have been obtained using `borrowObject` or a related method as defined in an implementation or sub-interface using a `key` that is equivalent to the one used to borrow the instance in the first place.
      Specified by:
        `returnObject` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key used to obtain the object
        `obj` - a `borrowed` instance to be returned.
      Throws:
        `java.lang.Exception`

    - #### invalidateObject

          public abstract void invalidateObject(K key,
                              V obj)
                                         throws java.lang.Exception

      Invalidates an object from the pool.

      By contract, `obj` must have been obtained using `borrowObject` using a `key` that is equivalent to the one used to borrow the `Object` in the first place.

      This method should be used when an object that has been borrowed is determined (due to an exception or other problem) to be invalid.

      Specified by:
        `invalidateObject` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - the key used to obtain the object
        `obj` - a `borrowed` instance to be returned.
      Throws:
        `java.lang.Exception`

    - #### addObject

          public void addObject(K key)
                         throws java.lang.Exception,
                                java.lang.UnsupportedOperationException

      Not supported in this base implementation. Always throws an `UnsupportedOperationException`, subclasses should override this behavior.
      Specified by:
        `addObject` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - ignored
      Throws:
        `java.lang.UnsupportedOperationException`
        `java.lang.Exception` - when `KeyedPoolableObjectFactory.makeObject(K)` fails.
        `java.lang.IllegalStateException` - after `KeyedObjectPool.close()` has been called on this pool.

    - #### getNumIdle

          public int getNumIdle(K key)
                         throws java.lang.UnsupportedOperationException

      Not supported in this base implementation.
      Specified by:
        `getNumIdle` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - ignored
      Returns:
        a negative value.
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

    - #### getNumActive

          public int getNumActive(K key)
                           throws java.lang.UnsupportedOperationException

      Not supported in this base implementation.
      Specified by:
        `getNumActive` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - ignored
      Returns:
        a negative value.
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

    - #### getNumIdle

          public int getNumIdle()
                         throws java.lang.UnsupportedOperationException

      Not supported in this base implementation.
      Specified by:
        `getNumIdle` in interface `KeyedObjectPool<K,V>`
      Returns:
        a negative value.
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

    - #### getNumActive

          public int getNumActive()
                           throws java.lang.UnsupportedOperationException

      Not supported in this base implementation.
      Specified by:
        `getNumActive` in interface `KeyedObjectPool<K,V>`
      Returns:
        a negative value.
      Throws:
        `java.lang.UnsupportedOperationException` - deprecated: when this implementation doesn't support the operation

    - #### clear

          public void clear()
                     throws java.lang.Exception,
                            java.lang.UnsupportedOperationException

      Not supported in this base implementation.
      Specified by:
        `clear` in interface `KeyedObjectPool<K,V>`
      Throws:
        `java.lang.UnsupportedOperationException`
        `java.lang.Exception`

    - #### clear

          public void clear(K key)
                     throws java.lang.Exception,
                            java.lang.UnsupportedOperationException

      Not supported in this base implementation.
      Specified by:
        `clear` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `key` - ignored
      Throws:
        `java.lang.UnsupportedOperationException`
        `java.lang.Exception`

    - #### close

          public void close()
                     throws java.lang.Exception

      Close this pool. This affects the behavior of `isClosed` and `assertOpen`.
      Specified by:
        `close` in interface `KeyedObjectPool<K,V>`
      Throws:
        `java.lang.Exception`

    - #### setFactory

          @Deprecated
          public void setFactory(KeyedPoolableObjectFactory<K,V> factory)
                          throws java.lang.IllegalStateException,
                                 java.lang.UnsupportedOperationException

      Deprecated. to be removed in pool 2.0
      Not supported in this base implementation. Always throws an `UnsupportedOperationException`, subclasses should override this behavior.
      Specified by:
        `setFactory` in interface `KeyedObjectPool<K,V>`
      Parameters:
        `factory` - the new KeyedPoolableObjectFactory
      Throws:
        `java.lang.IllegalStateException` - when the factory cannot be set at this time
        `java.lang.UnsupportedOperationException` - when this implementation doesn't support the operation

    - #### isClosed

          protected final boolean isClosed()

      Has this pool instance been closed.
      Returns:
        `true` when this pool has been closed.
      Since:
        Pool 1.4

    - #### assertOpen

          protected final void assertOpen()
                                   throws java.lang.IllegalStateException

      Throws an `IllegalStateException` when this pool has been closed.
      Throws:
        `java.lang.IllegalStateException` - when this pool has been closed.
      Since:
        Pool 1.4
      See Also:
        `isClosed()`

Copyright © 2000-2020 Apache Software Foundation. All Rights Reserved.